unit QButtonEx;

interface

uses
  Windows, Messages, SysUtils, Classes, QControls, QStdCtrls, Qt;

type
  TQtEvent = procedure(Sender: TComponent; Widget: QObjectH; Event: QEventH) of object;

  TButtonEx = class(TButton)
  private
    FOnQtEvent: TQtEvent;
  protected
    function EventFilter(Sender: QObjectH; Event: QEventH): Boolean; override;
  published
    property OnQtEvent: TQtEvent read FOnQtEvent write FOnQtEvent;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TButtonEx]);
end;

{ TButtonEx }

function TButtonEx.EventFilter(Sender: QObjectH; Event: QEventH): Boolean;
begin
  if Assigned(OnQtEvent) then
    OnQtEvent(Self, Sender, Event);
  //Return True if you want to hide the event
  Result := inherited EventFilter(Sender, Event)
end;

end.
