unit WindowProcTraceU;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ButtonEx, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Lst: TListView;
    Panel1: TPanel;
    chkWndProcHooked: TCheckBox;
    ButtonEx1: TButtonEx;
    procedure chkWndProcHookedClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonEx1Message(Sender: TComponent; var Msg: TMessage);
  end;

var
  Form1: TForm1;

implementation

uses MessageIDs;

{$R *.dfm}

procedure TForm1.chkWndProcHookedClick(Sender: TObject);
begin
  if chkWndProcHooked.Checked then
    ButtonEx1.OnMessage := ButtonEx1Message
  else
    ButtonEx1.OnMessage := nil
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  ButtonEx1.OnMessage := nil
end;

procedure TForm1.ButtonEx1Message(Sender: TComponent; var Msg: TMessage);
var
  Item: TListItem;
begin
  Item := Lst.Items.Add;
  Item.Caption := MsgIDToStr(Msg.Msg);
  Item.SubItems.Add(Format('$%x (%0:d)', [Msg.WParam]));
  Item.SubItems.Add(Format('$%x (%0:d)', [Msg.LParam]));
  Item.SubItems.Add(FormatDateTime('h:nn:ss.zzz', Time));
  Item.Selected := True;
  Item.Focused := True;
  Item.MakeVisible(False)
end;

end.
